'option explicit
'#include once "GL/gl.bi"
'#include once "GL/glu.bi"
#include "crt/string.bi"
'#Define factor 45/Atn(1) 

Declare Sub FBDrawPicture Lib "FB2DMaps" Alias "FBDrawPicture" (BitMap As Integer, Matrix As Integer, ByVal Size As Integer, ByVal Typ As Integer, ByVal BITS As Integer, ByVal NDM As Integer)


SUB FBDrawPicture(BitMap As Integer, Matrix As Integer, ByVal Size As Integer, ByVal Typ As Integer, ByVal BITS As Integer, ByVal NDM As Integer) EXPORT
DIM X As Integer, Y As INTEGER
DIM Q As UByte, R As Integer, D As INTEGER
Dim ROJO As Single, VERDE As Single, AZUL As SINGLE
Dim ValuesB (Size-1,Size-1) As UBYTE
Dim ValuesS (Size-1,Size-1) As USHORT
Dim Pixels (Size-1,Size-1) As INTEGER

SELECT CASE Typ
CASE 1
memcpy(@ValuesB(0,0), Matrix, Size*Size*Typ) 
Case 2
memcpy(@ValuesS(0,0), Matrix, Size*Size*Typ) 
End SELECT


FOR X = 0 TO Size-1
FOR Y = 0 TO Size-1

SELECT CASE Typ
CASE 1
R = ValuesB(X, Y)
Case 2
R = ValuesS(X, Y)
End SELECT

SELECT CASE BITS
CASE -1,0

If BITS=0 Then D=R Else D=255-R

ROJO=D
VERDE=D
AZUL=D

D=(ROJO*&H10000+VERDE*&H100+AZUL)

CASE 1
 If R>=NDM+200 Then D=&HFFFFFF Else If R>=NDM+160 Then D=&H006666 Else If R>=NDM+120 Then D=&H009966 Else If R>=NDM+80 Then D=&H009900 Else If R>=NDM+40 Then D=&H00CC00 Else If R>NDM Then D=&H00CCFF Else If R<NDM-120 Then D=&H660000 Else If R<NDM-80 Then D=&H990000 Else If R<NDM-40 Then D=&HCC0000 Else D=&HFF0000

Q = R MOD 40


AZUL=((D And &HFF0000)/&H10000):If AZUL>Q Then AZUL=AZUL-Q Else AZUL=0
VERDE=((D And &H00FF00)/&H100):If VERDE>Q Then VERDE=VERDE-Q Else VERDE=0
ROJO=(D And &H0000FF):If ROJO>Q Then ROJO=ROJO-Q Else ROJO=0

D=(ROJO*&H10000+VERDE*&H100+AZUL)

CASE 2

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=(INT(D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(ROJO*&H80000+VERDE*&H800+AZUL*8)
End SELECT

Pixels(Size-1-X,Y)=D

NEXT Y: NEXT X
memcpy(BitMap, @Pixels(0,0), Size*Size*SizeOf(Integer)) 


END SUB


