'based on ' mouse.bas' by  Don (don67geo@yahoo.com) 
'  modified and translated opengl mouse.c into hotbasic source. 
' 
$typecheck ON
$INCLUDE <RapidQ2.inc>
$INCLUDE <GL\QGL.inc>
$RESOURCE ICO_CARN AS "M:\CARNIVORES2\CARN2.ICO"

Declare Sub FBDrawPic3D Lib "FBRandomMapFuncs" Alias "FBDrawPic3D@24" (Z As INTEGER, ByVal MaxX As Integer, ByVal MaxY As Integer, ByVal MaxZ AS Integer, ByVal NDM As INTEGER, ByVal K AS SINGLE)
Declare Sub FBMoveSeaLevel Lib "FBRandomMapFuncs" Alias "FBMoveSeaLevel@20" (W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal NDM AS Integer)
Declare Sub FBInvertHeightMap Lib "FBRandomMapFuncs" Alias "FBInvertHeightMap@28" (Z AS INTEGER, W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer)
Declare Sub FBSwapRows Lib "FBRandomMapFuncs" Alias "FBSwapRows@12" (A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer)
Declare Sub FBProcessAfterLoad Lib "FBRandomMapFuncs" Alias "FBProcessAfterLoad@20" (Z AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer)
Declare Sub FBProcessAfterLoadBMP Lib "FBRandomMapFuncs" Alias "FBProcessAfterLoadBMP@28" (Z AS INTEGER, A AS INTEGER, W AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer)
Declare Sub FBGenRandom Lib "FBRandomMapFuncs" Alias "FBGenRandom@28" (Z AS INTEGER, W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer)
Declare Sub FBDrawPicture Lib "FB2DMaps" Alias "FBDrawPicture@24" (BitMap As Integer, Matrix As Integer, ByVal Size As Integer, ByVal Typ As Integer, ByVal BITS As Integer, ByVal NDM As Integer)

DECLARE SUB FormCreate
DECLARE SUB FormKeyDown (Key AS Word, KeyShift AS INTEGER)
DECLARE SUB FormMouseDown (Button%, X%, Y%, Shift%)
DECLARE SUB FormMouseMove (X%, Y%, Shift%)
DECLARE SUB FormMouseUp(Button%, X%, Y%, Shift%)
DECLARE SUB FormSize
DECLARE sub meshbuilder
DECLARE sub meshframe(state as integer, ox as integer, nx as integer, oy as integer, ny as integer)
DECLARE sub setrendermode
DECLARE sub setvisual(iw as integer, ih as integer)

DECLARE sub GenerateTerrain
DIM meshList as glInt

$define PAN    1
$define ROTATE 2
$define ZOOM   3
$define MaxX    1024
$define MaxY    1024
$define MaxZ    1024
defint mx,my,dx,dy
dim trans(3) as single
dim rotat(2) as single

DIM A?(MaxX-1,MaxY-1)
DIM W?(MaxX-1,MaxY-1)
DIM Z%(MaxX,MaxY)

 DIM X AS glInt
 DIM Y AS glInt
 DIM R0 AS glInt
 DIM R1 AS glInt
 DIM R2 AS glInt
 DIM R3 AS glInt
 DIM R4 AS glInt
' DIM A%(MaxX, MaxY)
 DEFINT D,M,N,R,S,T,H,V,K
 DEFSNG ROJO,VERDE,AZUL
' $typecheck OFF

DIM position(3) AS glFloat
position (0)=0
position (1)=1024
position (2)=0
position (3)=0

DIM diffuse(3) AS glFloat
diffuse (0)=1
diffuse (1)=1
diffuse (2)=1
diffuse (3)=1

DIM ambient(3) AS glFloat
ambient (0)=0
ambient (1)=0
ambient (2)=0
ambient (3)=0

DIM specular(3) AS glFloat
specular (0)=0
specular (1)=0
specular (2)=0
specular (3)=0

DECLARE SUB ChangeDirectories
DECLARE SUB ChangeDrive
DECLARE SUB LoadMapFile
DECLARE SUB SaveMapFile
DECLARE SUB InitScreen
DECLARE SUB DrawPicture
DECLARE SUB DrawPicture3D
DECLARE SUB ExitClick
DECLARE SUB FileOpen
DECLARE SUB FileSave
DECLARE SUB GenRandom
DECLARE SUB Proceed3D
DECLARE SUB Proceed0
DECLARE SUB Proceed1
DECLARE SUB Proceed2
DECLARE SUB Proceed3
DECLARE SUB Proceed4
DECLARE SUB Proceed5
DECLARE SUB Proceed6
DECLARE SUB Proceed7
DECLARE SUB Proceed8
DECLARE SUB Proceed9
DECLARE SUB Proceed10
DECLARE SUB Proceed11
DECLARE SUB MoveSeaLevel
DECLARE SUB InvertHeightMap
DECLARE SUB ExportBitMap
DECLARE SUB ImportBitMap
DECLARE SUB LoadBitMap
DECLARE SUB SaveBitMap
DECLARE SUB SwapRows
DECLARE SUB SeaLevelChange
DECLARE SUB OpenSeaForm
DECLARE SUB CloseSeaForm


DECLARE SUB CanvasPaint
DECLARE SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)

DIM BitMap AS QBITMAPEX
    BitMap.Width = 2048
    BitMap.Height = 1536
    BitMap.PixelFormat = pf32bit
    BitMap.Paint(0,0,0,0)    

DIM Font AS QFont
    Font.Name = "Arial"
    Font.Size = 12
    Font.Color = &H00FF00

DIM FileName$ as String
DIM Q AS SHORT
DIM Z AS SHORT
DIM YY AS SHORT
' DIM ROJO AS BYTE
' DIM VERDE AS BYTE
' DIM AZUL AS BYTE
DIM NDM AS BYTE
NDM = 128
DIM SeaLevel AS BYTE

DIM ChngDrv AS QMenuItem
    ChngDrv.Caption = "Change &Drive"
    ChngDrv.OnClick = ChangeDrive  

DIM RandomMap AS QMenuItem
    RandomMap.Caption = "Generate &Random Map"
    RandomMap.OnClick = GenRandom  

DIM OpenFile AS QMenuItem
    OpenFile.Caption = "&Open File"
    OpenFile.OnClick = FileOpen  

DIM SaveFile AS QMenuItem
    SaveFile.Caption = "&Save File"
    SaveFile.OnClick = FileSave  
    SaveFile.Enabled=False

DIM ExportMap AS QMenuItem
    ExportMap.Caption = "&Export Bitmap"
    ExportMap.OnClick = ExportBitMap  
    ExportMap.Enabled=False

DIM ImportMap AS QMenuItem
    ImportMap.Caption = "&Import Bitmap"
    ImportMap.OnClick = ImportBitMap  
    ImportMap.Enabled=True

DIM InvertMap AS QMenuItem
    InvertMap.Caption = "Invert &Heightmap"
    InvertMap.OnClick = InvertHeightMap  
    InvertMap.Enabled=False

DIM ChangeSeaLevel AS QMenuItem
    ChangeSeaLevel.Caption = "&Change Sea Level"
    ChangeSeaLevel.OnClick = OpenSeaForm  
    ChangeSeaLevel.Enabled=False

DIM ExitPrg AS QMenuItem
    ExitPrg.Caption = "E&xit"
    ExitPrg.OnClick = ExitClick
        
DIM FileMenu AS QMenuItem
    FileMenu.Caption = "&File"
    FileMenu.AddItems RandomMap, OpenFile, SaveFile, ExportMap, ImportMap, InvertMap, ChangeSeaLevel, ExitPrg
         
DIM Map3D AS QMenuItem
    Map3D.Caption = "&3D"
    Map3D.OnClick = Proceed3D
  
DIM SurfaceMap AS QMenuItem
    SurfaceMap.Caption = "&Surfaces"
    SurfaceMap.OnClick = Proceed0
    
DIM WaterMap AS QMenuItem
    WaterMap.Caption = "W&ater"
    WaterMap.OnClick = Proceed8
    
DIM ShowMenu AS QMenuItem
    ShowMenu.Caption = "S&how"
    ShowMenu.AddItems Map3D, SurfaceMap, WaterMap
    ShowMenu.Enabled=False


DEFINT state = 0
DIM GL AS QGL
'-- user interface here 
create Form as QFORM
  caption       = "3D View"
  center
  width         = 1024
  height        = 768
  onpaint       = meshbuilder
  onmouseup     = FormMouseUp
  onmousedown   = FormMouseDown
  onmousemove   = FormMouseMove
'  onshow        = FormCreate
  onkeydown     = FormKeyDown
  onresize      = FormSize
end create
 FormCreate
' GenerateTerrain
' Form.showmodal
' end

sub meshframe(state as integer, ox as integer, nx as integer, oy as integer, ny as integer)
    dx = ox - nx
    dy = ny - oy
    select case state
      case PAN:    trans(0) = trans(0) - dx
                   trans(1) = trans(1) - dy
      case ROTATE: rotat(0) = rotat(0) + (dy * 18.0) / 10.0
                   rotat(1) = rotat(1) - (dx * 18.0) / 10.0
      case ZOOM:   trans(2) = trans(2) - (dx + dy)
    end select
end sub

sub setrendermode
    glEnable(GL_DEPTH_TEST)
'    glEnable(GL_LIGHTING)
'    glEnable(GL_LIGHT0)
end sub

sub setvisual(iw as integer, ih as integer)
    defdbl aspect = iw/ih
    glViewport(0, 0, iw, ih)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity
'    gluPerspective(75.0,aspect,0.1,MAXZ*2.0)
 glOrtho(-Form.width/3,Form.width/3,-Form.height/3,Form.height/3,0.1,3000.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity
    glTranslatef(0.0, 0.0, -MaxZ*1.0)
end sub

sub meshbuilder
    ' rotate a triangle around 
    glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)
'    glLightfv GL_LIGHT0, GL_POSITION, position(0)
    glPushMatrix
    glTranslatef(trans(0), trans(1), trans(2))
        glRotatef(rotat(0), 1.0, 0.0, 0.0)
    glRotatef(rotat(1), 0.0, 1.0, 0.0)
    glClearColor(0.0,0.0,0.0,0.0)
'    glCallList(meshList)
DIM K AS SINGLE
 K = 0.125

'      glNewList(meshList,GL_COMPILE)
        glPolygonMode(GL_FRONT_AND_BACK, GL_FILL)
        glEnable(GL_CULL_FACE)
        glCullFace (GL_BACK)
'    glBegin(GL_QUADS)
    
FBDrawPic3D(VARPTR(Z%(0,0)),MaxX,MaxY,MaxZ,NDM,K)
'    glEnd
'    glEndList
    glPopMatrix
    GL.Flip
end sub


SUB FormCreate
    GL.Init(Form)
   setrendermode
      meshList=glGenLIsts(1)
END SUB

SUB FormMouseDown (Button%, X%, Y%, Shift%) 
  if Button% = 0 then state = ROTATE  'or state 
  if Button%= 1 then state = PAN 'or state 
'  if Button%= 2 then state = ZOOM 'or state 
  mx = X%'Screen.mouseX 
  my = Y%'Screen.mouseY 
END SUB

SUB FormMouseUp(Button%, X%, Y%, Shift%)
   state = 0
END SUB


SUB FormMouseMove (X%, Y%, Shift%)
     meshframe(state, mx, X%, my, Y%)
     mx = X%
     my = y%
     meshbuilder
     GL.Flip
END SUB

SUB FormKeyDown (Key AS Word, KeyShift AS INTEGER) 
  if key = 27 then
    GL.Close
    Form.close
  end if
'  if KeyShift THEN state = STATE XOR PAN
  SELECT CASE Key
'  CASE 33 ' Page Up
'  state = ZOOM
'  meshframe(state,0,2,0,0)
'     meshbuilder
'  state = 0
'     GL.Flip
'  CASE 34 ' Page Down
'  state = ZOOM
'  meshframe(state,2,0,0,0)
'     meshbuilder
'  state = 0
'     GL.Flip
  CASE 37 ' Left Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,2,0,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 38 ' Up Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,0,2,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 39 ' Right Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,2,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 40 ' Down Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,0,0,2)
     meshbuilder
  state = 0
     GL.Flip
  CASE ELSE
  state = 0
  meshframe(state,0,0,0,0)
     meshbuilder
     GL.Flip
  END SELECT
END SUB


SUB FormSize
  GL.Resize(form.clientWidth, form.clientHeight)
  setvisual(GL.width, GL.height)
  meshbuilder
END SUB
 
CREATE Form1 AS QForm
    IcoHandle = ICO_CARN
    Height = 300
    Width = 450
    BorderStyle = 2
CREATE MainMenu AS QMainMenu
    AddItems FileMenu, ShowMenu
END CREATE
CREATE Canvas AS QCanvas
    Visible = False
    OnPaint = CanvasPaint
    OnMouseMove=CanvasMouseMove
END CREATE
    OnResize = CanvasPaint
''CREATE ComboBox AS QComboBox
'  Parent=Form1
'' AddItems "0", "16", "32", "48", "64", "80", "96", "112", "128", "144", "160", "176", "192", "208", "224", "240"
'' ItemIndex = 8
'' OnChange = MoveSeaLevel
''END CREATE  
CREATE SeaForm AS QForm
    Parent=Form1
    IcoHandle = ICO_CARN
    BorderStyle = 3
  Height = 120
  Width = 300
  CREATE SeaLevelDesc AS QLabel
    Left = 5
    Top = 22
    Caption = "Sea Level:"
  END CREATE
    CREATE SeaLevelLabel AS QLabel
    Left = 270
        Top = 22
    Caption = "0"
  END CREATE
  CREATE SeaLevelScroll AS QScrollBar
    Left = 60
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Sea Level Height"
    OnChange = SeaLevelChange
  END CREATE
CREATE SaveSea AS QButton
  Parent = SeaForm
  Left = 20
  Top = 60
  Width = 110
  Caption = "Apply"
  OnClick = MoveSeaLevel
END CREATE
CREATE CloseSea AS QButton
  Parent = SeaForm
  Left = 160
  Top = 60
  Width = 110
  Caption = "Close"
  OnClick = CloseSeaForm
END CREATE
  Caption = "Sea Level"
'  onClose = CloseSeaForm
    WindowState=0
    Visible=False
END CREATE
    Center
  ShowModal
END CREATE


SUB MoveSeaLevel
    NDM=SeaLevel
    FBMoveSeaLevel(VARPTR(W?(0,0)),VARPTR(A?(0,0)),MaxX,MaxY,NDM)
END SUB

SUB InvertHeightMap
    FBInvertHeightMap(VARPTR(Z%(0,0)),VARPTR(W?(0,0)),VARPTR(A?(0,0)),MaxX,MaxY,MaxZ,NDM)
END SUB

SUB SwapRows
    FBSwapRows(VARPTR(A?(0,0)),MaxX,MaxY)
END SUB

SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)
DIM R
SELECT CASE Z
CASE 0
R = A?(Y, X)

CASE 1
R = W?(Y, X)

END SELECT
    Canvas.Hint=""
    Canvas.Hint=STR$(X)+","+STR$(Y)+":"+STR$(R)
END SUB      

SUB CanvasPaint
DIM W
DIM H
    W = Canvas.ClientWidth
    H = Canvas.ClientHeight
    Canvas.FillRect(0, 0, W, H, 0)
    
    CREATE RectArea as QRect
     Top=0
     Left=0
     Right=W
     Bottom=H
    END CREATE
    Canvas.StretchDraw(RectArea, Bitmap.BMP)
END SUB

SUB FileOpen
  DIM OpenDialog AS QOpenDialog

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "XM2 Files (*.xm2)|*.xm2|All Files (*.*)|*.*"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
        Form1.Caption="Viewing "+FileName$
    LoadMapFile
'    ShowMenu.Enabled=True
      END IF
END SUB

SUB FileSave
  DIM OpenDialog AS QOpenDialog

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "XM2 Files (*.xm2)|*.xm2|All Files (*.*)|*.*"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Form1.Caption="Viewing "+FileName$
    SaveMapFile
'    ShowMenu.Enabled=True
      END IF
END SUB

SUB ImportBitMap
  DIM OpenDialog AS QOpenDialog

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "BMP Files (*.bmp)|*.bmp|All Files (*.*)|*.*"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Form1.Caption="Importing "+FileName$
    LoadBitMap
'    ShowMenu.Enabled=True
      END IF
END SUB

SUB ExportBitMap
  DIM OpenDialog AS QOpenDialog

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "BMP Files (*.bmp)|*.bmp|All Files (*.*)|*.*"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Form1.Caption="Exporting "+FileName$
    SaveBitMap
'    ShowMenu.Enabled=True
      END IF
END SUB

     
SUB Proceed3D

Z=10
YY=0
InitScreen

END SUB

SUB Proceed0

Z=0
YY=1
InitScreen

END SUB

SUB Proceed8

Z=1
YY=1
InitScreen

END SUB

SUB ExitClick
  Form1.Close
END SUB  


SUB LoadMapFile

DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
Form1.Caption="Reading Surface Data..."
Form1.Show
File.LoadArray(A?(0, 0),MaxX*MaxY)
Form1.Caption="Reading Water Data..."
Form1.Show
File.LoadArray(W?(0, 0),MaxX*MaxY)
File.Close
FBProcessAfterLoad(VARPTR(Z%(0,0)),VARPTR(A?(0,0)),MaxX,MaxY,MaxZ)
Form1.Caption="Done"
Form1.Show
ShowMenu.Enabled=True
SaveFile.Enabled=True
ExportMap.Enabled=True
InvertMap.Enabled=True
ChangeSeaLevel.Enabled=True


END SUB

SUB SaveMapFile

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Form1.Caption="Writing Surface Data..."
Form1.Show
File.SaveArray(A?(0, 0),MaxX*MaxY)
Form1.Caption="Writing Water Data..."
Form1.Show
File.SaveArray(W?(0, 0),MaxX*MaxY)
Form1.Caption="Done"
Form1.Show
File.Close

END SUB

SUB LoadBitMap

DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
IF File.Size=MaxX*MaxY+&H436 THEN
Form1.Caption="Reading Header..."
Form1.Show
DIM BMSignature$ AS STRING * 2
BMSignature$=File.ReadStr(2)
DIM BMFileSize&
File.Read(BMFileSize&)
DIM BMreserved&
File.Read(BMreserved&)
DIM BMDataOffset&
File.Read(BMDataOffset&)
DIM BMSize&
File.Read(BMSize&)
DIM BMWidth&
File.Read(BMWidth&)
DIM BMHeight&
File.Read(BMHeight&)
DIM BMPlanes%
File.Read(BMPlanes%)
DIM BMBitCount%
File.Read(BMBitCount%)
DIM BMCompression&
File.Read(BMCompression&)
DIM BMImageSize&
File.Read(BMImageSize&)
DIM BMXpixelsPerM&
File.Read(BMXpixelsPerM&)
DIM BMYpixelsPerM&
File.Read(BMYpixelsPerM&)
DIM BMColorsUsed&
File.Read(BMColorsUsed&)
DIM BMColorsImportant&
File.Read(BMColorsImportant&)
DIM BMColorTable$ AS STRING * 1024
BMColorTable$=File.ReadBinStr(1024)
Form1.Caption="Reading Bitmap..."
Form1.Show
'File.LoadArray(A?(0, 0),1024*1024)
'SwapRows
FOR X = 0 TO MaxX-1
File.LoadArray(A?(MaxX-1-X, 0),MaxY)
NEXT X

FBProcessAfterLoadBMP(VARPTR(Z%(0,0)),VARPTR(A?(0,0)),VARPTR(W?(0,0)),MaxX,MaxY,MaxZ,NDM)

Form1.Caption="Done"
Form1.Show
ShowMenu.Enabled=True
SaveFile.Enabled=True
ExportMap.Enabled=True
InvertMap.Enabled=True
ChangeSeaLevel.Enabled=True
ELSE
Form1.Caption="Not a valid uncompressed "+STR$(MaxX)+"x"+STR$(MaxY)+" 8-bit bitmap!"
Form1.Show
END IF    
File.Close



END SUB

SUB SaveBitMap

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Form1.Caption="Writing Header..."
Form1.Show
DIM BMSignature$ AS STRING * 2
DIM BMFileSize&
DIM BMreserved&
DIM BMDataOffset&
DIM BMSize&
DIM BMWidth&
DIM BMHeight&
DIM BMPlanes%
DIM BMBitCount%
DIM BMCompression&
DIM BMImageSize&
DIM BMXpixelsPerM&
DIM BMYpixelsPerM&
DIM BMColorsUsed&
DIM BMColorsImportant&
DIM BMColorTable$ AS STRING * 1024
DIM Palette&
BMSignature$="BM":File.WriteStr(BMSignature$,2)
BMFileSize&=MaxX*MaxY+&H436:File.Write(BMFileSize&)
BMreserved&=0:File.Write(BMreserved&)
BMDataOffset&=&H436:File.Write(BMDataOffset&)
BMSize&=&H28:File.Write(BMSize&)
BMWidth&=MaxY:File.Write(BMWidth&)
BMHeight&=MaxX:File.Write(BMHeight&)
BMPlanes%=1:File.Write(BMPlanes%)
BMBitCount%=8:File.Write(BMBitCount%)
BMCompression&=0:File.Write(BMCompression&)
BMImageSize&=0:File.Write(BMImageSize&)
BMXpixelsPerM&=1:File.Write(BMXpixelsPerM&)
BMYpixelsPerM&=1:File.Write(BMYpixelsPerM&)
BMColorsUsed&=&H100:File.Write(BMColorsUsed&)
BMColorsImportant&=0:File.Write(BMColorsImportant&)
'BMColorTable$=File.ReadStr(1024)
FOR X=0 TO 255
Palette&=X*&H10101
File.Write(Palette&)
NEXT X
Form1.Caption="Writing Bitmap..."
Form1.Show
'File.SaveArray(A?(0, 0),1024*1024)
'SwapRows
FOR X = 0 TO MaxX-1
File.SaveArray(A?(MaxX-1-X, 0),MaxY)
NEXT X

Form1.Caption="Done"
Form1.Show
File.Close

END SUB

SUB InitScreen

Canvas.Visible = False

'Form.ClientWidth = 2048
'Form.ClientHeight = 1536
'Form1.Width = 2048
'Form1.Height = 1536
'Form1.WindowState=2
'Form1AutoScroll = True

'Canvas.Parent = Form1
'Canvas.Font = Font
'Canvas.Color = 0
'Canvas.OnPaint = DrawPicture

Form1.Color = 0
Form1.Caption="Carnivores 2/Ice Age Random Maps - "+FileName$+" - (C) 2008 by M.A.Ch.F."
'Form.Onresize = Resize

IF YY=0 THEN DrawPicture3D
IF YY=1 THEN DrawPicture
Form1.Center
Canvas.Visible = True
Canvas.Repaint
Canvas.ShowHint=True

END SUB

SUB GenRandom
ShowMenu.Enabled=False
SaveFile.Enabled=False
    FBGenRandom(VARPTR(Z%(0,0)),VARPTR(W?(0,0)),VARPTR(A?(0,0)),MaxX,MaxY,MaxZ,NDM)
ShowMenu.Enabled=True
SaveFile.Enabled=True
ExportMap.Enabled=True
InvertMap.Enabled=True
ChangeSeaLevel.Enabled=True

END SUB



SUB DrawPicture
DIM W AS INTEGER
DIM R AS INTEGER
DIM BITS AS INTEGER, TYP AS INTEGER

IF Z<10 THEN W=MaxX ELSE W=MaxX/2
Form1.ClientWidth = 1024
Form1.ClientHeight = 1024
Canvas.Width = 1024
Canvas.Height = 1024
Canvas.ClientWidth = 1024
Canvas.ClientHeight = 1024
BitMap.Width = W
BitMap.Height = W
BitMap.FillRect(0, 0, W, W, 0)

SELECT CASE Z
CASE 0
R = VARPTR(A?(0, 0))
BITS = 1
TYP = 1

CASE 1
R = VARPTR(W?(0, 0))
BITS = 0
TYP = 1

END SELECT

FBDrawPicture(BitMap.Pointer, R, W, TYP, BITS, NDM)
Form1.Show
END SUB


SUB DrawPicture3D
 FormSize
 Form.showmodal
END SUB


SUB SeaLevelChange
    SeaLevel=SeaLevelScroll.Position
    SeaLevelLabel.Caption = STR$(SeaLevel)
END SUB

SUB OpenSeaForm
    SeaLevel=NDM
    SeaLevelScroll.Position=SeaLevel
    SeaForm.Visible=True
    SeaForm.Show
    SeaLevelChange
END SUB

SUB CloseSeaForm
    SeaForm.Close
END SUB
