'option explicit
#include once "GL/gl.bi"
'#include once "GL/glu.bi"
#include "crt/string.bi"
#Define factor 45/Atn(1) 

Declare Sub FBDrawPic3D Lib "FBRandomMapFuncs" Alias "FBDrawPic3D" (Z As INTEGER , ByVal MaxX As Integer, ByVal MaxY As Integer, ByVal MaxZ AS Integer, ByVal NDM As INTEGER, ByVal K AS SINGLE )
Declare Sub FBMoveSeaLevel Lib "FBRandomMapFuncs" Alias "FBMoveSeaLevel" (W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal NDM AS Integer)
Declare Sub FBInvertHeightMap Lib "FBRandomMapFuncs" Alias "FBInvertHeightMap" (Z AS INTEGER, W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer)
Declare Sub FBSwapRows Lib "FBRandomMapFuncs" Alias "FBSwapRows" (A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer)
Declare Sub FBProcessAfterLoad Lib "FBRandomMapFuncs" Alias "FBProcessAfterLoad" (Z AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer)
Declare Sub FBProcessAfterLoadBMP Lib "FBRandomMapFuncs" Alias "FBProcessAfterLoadBMP" (Z AS INTEGER, A AS INTEGER, W AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer)
Declare Sub FBGenRandom Lib "FBRandomMapFuncs" Alias "FBGenRandom" (Z AS INTEGER, W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer)


Sub FBDrawPic3D (Z As INTEGER, ByVal MaxX As Integer, ByVal MaxY As Integer, ByVal MaxZ As Integer, ByVal NDM As INTEGER, ByVal K AS SINGLE ) Export
Dim X As Integer, Y As INTEGER
 DIM R1 AS Integer
 DIM R2 AS Integer
 DIM R3 AS Integer
 DIM R4 AS Integer
Dim R As Integer
Dim ROJO As Single, VERDE As Single, AZUL As SINGLE
'Dim ANG As Single
Dim Q As Integer
Dim D As Integer
Dim Zfactor As Integer : ZFactor = Int(MaxZ/256)

Dim ZZ(MaxX,MaxY) As SHORT
memcpy(@ZZ(0,0), Z, (MaxX+1)*(MaxY+1)*SIZEOF(SHORT)) 
For Y = 0 To MaxY -1
    glBegin(GL_QUAD_STRIP)
For X = 0 to MaxX -1
R1 = ZZ(X, Y + 1)/Zfactor: Rem If R1 < 0 Then R1 = 0
R2 = ZZ(X, Y)/Zfactor: Rem If R2 < 0 Then R2 = 0
R3 = ZZ(X + 1, Y + 1)/Zfactor: Rem If R3 < 0 Then R3 = 0
R4 = ZZ(X + 1, Y)/Zfactor: Rem If R4 < 0 Then R4 = 0


R = (R4 + R1 + R2 + R3)/4
'R = (R1 + R2)/2
' ANG = ( Atn( sqr( (R3 - R1)*(R3 - R1) + (R2 - R1)*(R2 - R1) ) ) )*Factor
' If ANG<0 Then ANG=ANG+90
'Q=int (ANG)
Q = INT ( Factor * Atn( sqr( (R3 - R1)*(R3 - R1) + (R2 - R1)*(R2 - R1) ) ) ): If Q<0 Then Q=Q+90
'Q = INT ( Factor * Atn(R2 - R1) ): If Q<0 Then Q=Q+90

If R>=NDM+200 Then D=&HFFFFFF Else If R>=NDM+160 Then D=&H006666 Else If R>=NDM+120 Then D=&H009966 Else If R>=NDM+80 Then D=&H009900 Else If R>=NDM+40 Then D=&H00CC00 Else If R>NDM Then D=&H00CCFF Else If R<NDM-120 Then D=&H660000 Else If R<NDM-80 Then D=&H990000 Else If R<NDM-40 Then D=&HCC0000 Else D=&HFF0000

AZUL=((D And &HFF0000)/&H10000):If AZUL>Q Then AZUL=AZUL-Q Else AZUL=0
VERDE=((D And &H00FF00)/&H100):If VERDE>Q Then VERDE=VERDE-Q Else VERDE=0
ROJO=(D And &H0000FF):If ROJO>Q Then ROJO=ROJO-Q Else ROJO=0

glColor3f(ROJO/255,VERDE/255,AZUL/255)
'glNormal3i(R1-R3,1,R2-R1)
glVertex3i(MaxX/2-X, R1*K, Y+1-MaxY/2)
'glNormal3i(R2-R1,1,R4-R2)
glVertex3i(MaxX/2-X, R2*K, Y-MaxY/2)
'glNormal3i(R4-R2,1,R3-R4)
'glVertex3i(MaxX/2-X-1, R4*K, Y-MaxY/2)
'glNormal3i(R3-R4,1,R1-R3)
'glVertex3i(MaxX/2-X-1, R3*K, Y+1-MaxY/2)

Next X
glVertex3i(MaxX/2-X-1, R3*K, Y+1-MaxY/2)
glVertex3i(MaxX/2-X-1, R4*K, Y-MaxY/2)
glEnd
Next Y

End Sub


Sub FBMoveSeaLevel (W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal NDM AS Integer) Export
Dim WW(MaxX-1,MaxY-1) As UByte, AA(MaxX-1,MaxY-1) As UByte, X As Integer, Y As INTEGER
memcpy(@AA(0,0), A, (MaxX)*(MaxY)*SIZEOF(UBYTE)) 

    FOR X = 0 TO MaxX-1
    FOR Y = 0 TO MaxY-1
    WW(X, Y) = 0: IF AA(X, Y) > NDM THEN WW(X, Y) = 255
    NEXT Y: NEXT X
memcpy(W, @WW(0,0), (MaxX)*(MaxY)*SIZEOF(UBYTE)) 

End Sub

Sub FBInvertHeightMap (Z AS INTEGER, W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer) Export
Dim WW(MaxX-1,MaxY-1) As UByte, AA(MaxX-1,MaxY-1) As UByte, X As Integer, Y As INTEGER
Dim ZZ(MaxX,MaxY) As SHORT
Dim Zfactor As Integer : ZFactor = Int(MaxZ/256)
memcpy(@ZZ(0,0), Z, (MaxX+1)*(MaxY+1)*SIZEOF(SHORT)) 

    FOR X = 0 TO MaxX
    FOR Y = 0 TO MaxY
    ZZ(X, Y) = MaxZ-1 - ZZ(X, Y)
    If (X < MaxX AND Y<MaxY) Then AA(X, Y) = ZZ(X, Y)\Zfactor : If AA(X, Y) > NDM THEN WW(X, Y) = 255 Else WW(X, Y) = 0
    NEXT Y: NEXT X
memcpy(Z, @ZZ(0,0), (MaxX+1)*(MaxY+1)*SIZEOF(SHORT)) 
memcpy(W, @WW(0,0), (MaxX)*(MaxY)*SIZEOF(UBYTE)) 
memcpy(A, @AA(0,0), (MaxX)*(MaxY)*SIZEOF(UBYTE)) 
End Sub

Sub FBSwapRows (A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer) Export

    DIM AA(MaxX-1,MaxY-1) As UByte, TEMP As UByte, X As Integer, Y As Integer
memcpy(@AA(0,0), A, (MaxX)*(MaxY)*SIZEOF(UBYTE)) 
    FOR X = 0 TO MaxX/2-1
    FOR Y = 0 TO MaxY-1
        TEMP = AA(X,Y)
    AA(X,Y) = AA(MaxX-1-X,Y)
    AA(MaxX-1-X,Y) = TEMP
    NEXT Y:NEXT X
memcpy(A, @AA(0,0), (MaxX)*(MaxY)*SIZEOF(UBYTE)) 
End Sub

Sub FBProcessAfterLoad (Z AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer) Export

DIM AA(MaxX-1,MaxY-1) As UByte, ZZ(MaxX,MaxY) As SHORT, X As Integer, Y As Integer
Dim Zfactor As Integer : ZFactor = Int(MaxZ/256)
memcpy(@AA(0,0), A, (MaxX)*(MaxY)*SIZEOF(UBYTE)) 
For X = 0 TO MaxX
FOR Y = 0 TO MaxY
If (X < MaxX AND Y<MaxY) THEN ZZ(X, Y) = AA(X, Y)*Zfactor Else ZZ(X, Y) = MaxZ/2
NEXT Y: NEXT X
memcpy(Z, @ZZ(0,0), (MaxX+1)*(MaxY+1)*SIZEOF(SHORT)) 
End Sub

Sub FBProcessAfterLoadBMP (Z AS INTEGER, A AS INTEGER, W AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ As Integer, ByVal NDM As INTEGER) EXPORT

Dim WW(MaxX-1,MaxY-1) As UByte, AA(MaxX-1,MaxY-1) As UByte, X As Integer, Y As INTEGER
Dim ZZ(MaxX,MaxY) As SHORT
Dim Zfactor As Integer : ZFactor = Int(MaxZ/256)
memcpy(@AA(0,0), A, (MaxX)*(MaxY)*SIZEOF(UBYTE)) 
For X = 0 TO MaxX
FOR Y = 0 TO MaxY
If (X < MaxX AND Y<MaxY) Then
	ZZ(X, Y) = AA(X, Y)*Zfactor
	If AA(X, Y) > NDM THEN WW(X, Y) = 255 Else WW(X, Y) = 0
Else
ZZ(X, Y) = MaxZ/2
End If
NEXT Y: NEXT X
memcpy(Z, @ZZ(0,0), (MaxX+1)*(MaxY+1)*SIZEOF(SHORT)) 
memcpy(W, @WW(0,0), (MaxX)*(MaxY)*SIZEOF(UBYTE)) 
End Sub

Sub FBGenRandom (Z AS INTEGER, W AS INTEGER, A AS INTEGER, ByVal MaxX AS Integer, ByVal MaxY AS Integer, ByVal MaxZ AS Integer, ByVal NDM AS Integer) Export
Dim WW(MaxX-1,MaxY-1) As UByte, AA(MaxX-1,MaxY-1) As UByte
Dim ZZ(MaxX,MaxY) As SHORT
Dim M As Integer, N As INTEGER
Dim R As Integer, S As INTEGER
Dim D As Integer, K As INTEGER
Dim H As Integer, V As INTEGER
Dim Zfactor As Integer : ZFactor = Int(MaxZ/256)
For M=0 TO MaxX: FOR N=0 TO MaxY
ZZ(M, N) = MaxZ/2
NEXT N: NEXT M
AA(0,0)=128
If NDM>128 THEN WW(0,0)=0 Else WW(0,0)=255

RANDOMIZE TIMER
S = MaxZ: R = 1
WHILE S>1
D = Int (S / 2): K = S
FOR N = 1 TO R
H = N * S - D
ZZ(H, MaxX) = Int((ZZ(H+D, MaxX) + ZZ(H-D, MaxX)) / 2) + Int((Rnd-0.5)*K)
ZZ(MaxY, H) = Int((ZZ(MaxY, H+D) + ZZ(MaxY, H-D)) / 2) + Int((Rnd-0.5)*K)
FOR M = 1 TO R
H = N * S - D: V = M * S - D
ZZ(H, V) = Int((ZZ(H + D, V + D) + ZZ(H + D, V - D) + ZZ(H - D, V - D) + ZZ(H - D, V + D)) / 4) + Int((Rnd-0.5)*K)
'If ZZ(H,V)<0 Then AA(H,V)=0 Else If ZZ(H,V)>MaxZ-1 Then AA(H,V)=255 Else AA(H, V) = Int(ZZ(H, V)/Zfactor) 
'If AA(H, V) > NDM THEN WW(H, V) = 255 Else WW(H, V) = 0
ZZ(H - D, V) = Int((ZZ(H - D, V - D) + ZZ(H - D, V + D) + ZZ(H, V)) / 3) + Int((Rnd-0.5)*K)
'ZZ(H - D, V) = (ZZ(H - D, V - D) + ZZ(H - D, V + D)) \ 2 + Int((Rnd-0.5)*K)
'If ZZ(H-D,V)<0 Then AA(H-D,V)=0 Else If ZZ(H-D,V)>MaxZ-1 Then AA(H-D,V)=255 Else AA(H-D, V) = Int(ZZ(H-D, V)/Zfactor)
'If AA(H-D, V) > NDM THEN WW(H-D, V) = 255 Else WW(H-D, V) = 0
ZZ(H, V - D) = Int((ZZ(H - D, V - D) + ZZ(H + D, V - D) + ZZ(H, V)) / 3) + Int((Rnd-0.5)*K)
'ZZ(H, V - D) = (ZZ(H - D, V - D) + ZZ(H + D, V - D)) \ 2 + Int((Rnd-0.5)*K)
'If ZZ(H,V-D)<0 Then AA(H,V-D)=0 Else If ZZ(H,V-D)>MaxZ-1 Then AA(H,V-D)=255 Else AA(H, V-D) = Int(ZZ(H, V-D)/Zfactor)
'If AA(H, V-D) > NDM THEN WW(H, V-D) = 255 Else WW(H, V-D) = 0
NEXT M: NEXT N
S = D: R = R * 2
WEND
For M=0 TO MaxX-1: FOR N=0 TO MaxY-1
If Int(ZZ(M,N)/ZFactor)<0 Then AA(M,N) = 0 Else If Int(ZZ(M,N)/ZFactor)>255 Then AA(M,N) = 255 Else AA(M,N)=Int(ZZ(M,N)/Zfactor)
If AA(M,N) > NDM THEN WW(M,N) = 255 Else WW(M,N) = 0 
Next N: NEXT M

memcpy(Z, @ZZ(0,0), (MaxX+1)*(MaxY+1)*SIZEOF(SHORT)) 
memcpy(W, @WW(0,0), (MaxX)*(MaxY)*SIZEOF(UBYTE)) 
memcpy(A, @AA(0,0), (MaxX)*(MaxY)*SIZEOF(UBYTE)) 

End Sub

